// Fill out your copyright notice in the Description page of Project Settings.

#include "OffAxisBlueprintFunctionLibrary.h"
#include "EngineUtils.h"

int32 UOffAxisBlueprintFunctionLibrary::LoadScreenId()
{
	int32 id = -1;
	FString result;
	FString filename = FPaths::ProjectSavedDir() + "../screencfg/screenid.txt";
	//filename = "C:/UnrealProjects/cavexr/screencfg/screenid.txt";
	GEngine->AddOnScreenDebugMessage(-1, 30.0f, FColor::Green, filename);
	if (FFileHelper::LoadFileToString(result, *filename))
	{
		//GEngine->AddOnScreenDebugMessage(-1, 30.0f, FColor::Green, result);
		id = (FCString::Atoi(*result));
	}

	return id;
}

TArray<FScreenData> UOffAxisBlueprintFunctionLibrary::LoadConfig(FString filename)
{
	TArray<FScreenData> screenData;
	FString result;
	filename = FPaths::ProjectSavedDir() + "../screencfg/" + filename;
	//filename = "C:/UnrealProjects/cavexr/screencfg/3cave.txt";
	//GEngine->AddOnScreenDebugMessage(-1, 30.0f, FColor::Green, filename);

	if (FFileHelper::LoadFileToString(result, *filename))
	{

		TArray<FString> stringData;
		FString comma = "\n";
		int32 num = 0;
		num = result.ParseIntoArray(stringData, *comma);

		for (int i = 1; i < stringData.Num(); i++)
		{

			comma = " ";
			TArray<FString> lineData;

			num = stringData[i].ParseIntoArray(lineData, *comma);
			FScreenData item;
			item.id = (FCString::Atoi(*lineData[0]));
			item.name = lineData[1];

			double x = (FCString::Atod(*lineData[2]));
			double y = (FCString::Atod(*lineData[3]));
			double z = (FCString::Atod(*lineData[4]));
			item.center = FVector(x, y, z);

			float rx = (FCString::Atof(*lineData[5]));
			float ry = (FCString::Atof(*lineData[6]));
			float rz = (FCString::Atof(*lineData[7]));
			item.rot = FRotator(ry, rz, rx);

			float px = (FCString::Atof(*lineData[8]));
			float py = (FCString::Atof(*lineData[9]));
			item.resolution = FVector2D(px, py);
			

			item.width = (FCString::Atof(*lineData[10]));
			item.height = (FCString::Atof(*lineData[11]));


			screenData.Add(item);
		}
	}

	return screenData;
}




