/******************************************************************************
 * File: SpacesARCameraImageTexture.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "ARTextures.h"
#include "Engine/Texture2D.h"
#include "SpacesARCameraImageTexture.generated.h"

/**
 * 
 */
UCLASS()
class USpacesARCameraImageTexture : public UARTextureCameraImage
{
	GENERATED_BODY()
public:
	
	USpacesARCameraImageTexture();
	virtual ~USpacesARCameraImageTexture() override;
	
	UPROPERTY(BlueprintReadOnly, Category = "AR Camera Capture")
	UTexture2D* FrameRGBTexture = nullptr;

	void UpdateFrameRGBTexture(uint8_t* FrameData, const FVector2D& ImageSize);
	bool CreateFrameRGBTexture(const FVector2D& ImageSize, const FName& ImageName);
	
};
