/******************************************************************************
 * File: SpacesCameraCapture.cpp
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */


#include "SpacesCameraCapture.h"
#include "CameraAccess/SpacesCameraAccessExtension.h"

FSpacesCameraCapture::FSpacesCameraCapture()
{
	UE_LOG(LogSpacesRuntime, Log, TEXT("Startup SpacesCameraCapture"));
}

FSpacesCameraCapture::~FSpacesCameraCapture()
{
	UE_LOG(LogSpacesRuntime, Log, TEXT("Shutdown SpacesCameraCapture"));
	Captures.Empty();
}

void FSpacesCameraCapture::Initialize()
{
	UE_LOG(LogSpacesRuntime, Log, TEXT("Initialize SpacesCameraCapture"));
	TryAddCapture(ESpacesExtension::CameraAccess);
}

bool FSpacesCameraCapture::OnGetCameraIntrinsics(FARCameraIntrinsics& OutCameraIntrinsics) const
{
	bool bSuccess = true;
	for(const auto SpacesCapture : Captures)
	{
		bSuccess = SpacesCapture->OnGetCameraIntrinsics(OutCameraIntrinsics);
	}
	return bSuccess;
}

UARTexture* FSpacesCameraCapture::OnGetARTexture(EARTextureType TextureType) const
{
	UARTexture* ARTexture = nullptr;
	for(const auto SpacesCapture : Captures)
	{
		ARTexture = SpacesCapture->OnGetARTexture(TextureType);
	}
	return ARTexture;
}

EARCaptureType FSpacesCameraCapture::GetType()
{
	return EARCaptureType::Camera;
}
