﻿/******************************************************************************
 * File: FSpacesCapture.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "External/openxr/openxr.h"
#include "SpacesExtension.h"
#include "IOpenXRExtensionPlugin.h"


class FSpacesCapture : public IOpenXRCustomCaptureSupport
{
public:

	virtual void Initialize() = 0;
	virtual EARCaptureType GetType() = 0;

	virtual bool IsEnabled() const override final;
	virtual bool OnToggleARCapture(const bool bOnOff) override final;
	virtual TArray<FARTraceResult> OnLineTraceTrackedObjects(const TSharedPtr<FARSupportInterface, ESPMode::ThreadSafe> ARCompositionComponent, const FVector Start, const FVector End, const EARLineTraceChannels TraceChannels) override final;

	FSpacesCapture() = default;
	virtual ~FSpacesCapture() = default;
	
protected:
	
	TArray<FSpacesCaptureExtension*> Captures;
	bool TryAddCapture(ESpacesExtension Extension);
};