﻿/******************************************************************************
 * File: SpacesSpatialMapping.cpp
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#include "SpacesSpatialMapping.h"

#include "SpacesCommon.h"

#include "PlaneDetection/SpacesPlaneDetectionExtension.h"
#include "HitTesting/SpacesHitTestingExtension.h"

void FSpacesSpatialMapping::Initialize()
{
	UE_LOG(LogSpacesRuntime, Log, TEXT("Initialize SpacesSpatialMapping"));
	if(!TryAddCapture(ESpacesExtension::PlaneDetection))
	{
		/* If Retina PD is disabled, fallback to 3DR PD */
		TryAddCapture(ESpacesExtension::Meshing);
	}
	/* Hit Testing extension should be only in ONE custom capture to prevent duplicated results */
	TryAddCapture(ESpacesExtension::HitTesting);
}

EARCaptureType FSpacesSpatialMapping::GetType()
{
	return EARCaptureType::SpatialMapping;
}
