/******************************************************************************
 * File: SpacesInputHostControllerExtension.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "SpacesExtension.h"

class FSpacesInputHostControllerExtension :  public FSpacesExtension
{
	
public:
	
	FSpacesInputHostControllerExtension();
	virtual ~FSpacesInputHostControllerExtension() override;

	/** IOpenXRExtensionPlugin implementation */
    virtual FString GetDisplayName() override;
	virtual bool GetInteractionProfile(XrInstance InInstance, FString& OutKeyPrefix, XrPath& OutPath, bool& OutHasHaptics) override;

	virtual bool GetControllerModel(XrInstance InInstance, XrPath InInteractionProfile, XrPath InDevicePath, FSoftObjectPath& OutPath) override;
	
	void SetHapticsDuration(float Duration);

	float GetHapticsDuration() const;

	void SetHapticsFrequency(float Frequency);

	float GetHapticsFrequency() const;

	void SetHapticsAmplitude(float Amplitude);

	float GetHapticsAmplitude() const;

private:

	XrPath InteractionProfile = XR_NULL_PATH;
	
	float HapticsDuration = 0.0f;

	float HapticsFrequency = 0.0f;
	
	float HapticsAmplitude = 0.0f;
};
