/******************************************************************************
 * File: SpacesInputXRControllerExtension.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "SpacesExtension.h"

class FSpacesInputXRControllerExtension :  public FSpacesExtension
{
	
public:
	
	FSpacesInputXRControllerExtension();
	virtual ~FSpacesInputXRControllerExtension() override;

	/** IOpenXRExtensionPlugin implementation */
    virtual FString GetDisplayName() override;
	virtual bool GetInteractionProfile(XrInstance InInstance, FString& OutKeyPrefix, XrPath& OutPath, bool& OutHasHaptics) override;

	virtual bool GetControllerModel(XrInstance InInstance, XrPath InInteractionProfile, XrPath InDevicePath, FSoftObjectPath& OutPath) override;

private:

	XrPath InteractionProfile = XR_NULL_PATH;
	
};
