﻿/******************************************************************************
* File: PermissionHelperWrapper.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"

#if PLATFORM_ANDROID
#if USE_ANDROID_JNI
#include "JavaClassObjectExtended.h"

// Wrapper for com/google/vr/sdk/samples/permission/PermissionHelper
class FPermissionHelperWrapper : public FJavaClassObjectExtended
{

private:

	static FName GetClassName();
    
	FJavaClassMethod CheckPermissionMethod;
	FJavaClassMethod AcquirePermissionsMethod;
    
public:

	FPermissionHelperWrapper();

	bool CheckPermission(const FString& Permission);
	void AcquirePermissions(const TArray<FString>& Permissions);
    
};

#endif //USE_ANDROID_JNI
#endif //PLATFORM_ANDROID