﻿/******************************************************************************
 * File: UEServicesHelperWrapper.cpp
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#include "RuntimeCheckerWrapper.h"

#if PLATFORM_ANDROID
#include "Android/AndroidApplication.h"

#if USE_ANDROID_JNI

FName FRuntimeCheckerWrapper::GetClassName()
{
	return FName("com/qualcomm/snapdragon/spaces/unrealserviceshelper/RuntimeChecker");
}

FRuntimeCheckerWrapper::FRuntimeCheckerWrapper()
    : FJavaClassObjectExtended(GetClassName(), "()V")
    , CheckInstalledMethod(GetStaticClassMethod("CheckInstalled", "(Landroid/app/Activity;Landroid/content/Context;)Z"))
    , CheckCameraPermissionsMethod(GetStaticClassMethod("CheckCameraPermissions", "(Landroid/app/Activity;)Z"))
{}

bool FRuntimeCheckerWrapper::CheckInstalled()
{
    return CallStaticMethod<bool>(CheckInstalledMethod, AndroidJavaEnv::GetGameActivityThis(), *(AndroidJavaEnv::GetApplicationContextThis()));
}

bool FRuntimeCheckerWrapper::CheckCameraPermissions()
{
	return CallStaticMethod<bool>(CheckCameraPermissionsMethod, AndroidJavaEnv::GetGameActivityThis());
}
#endif //USE_ANDROID_JNI
#endif //PLATFORM_ANDROID