﻿/******************************************************************************
 * File: UEServicesHelperWrapper.cpp
 * Copyright (c) 2021 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#include "SpacesControllerWrapper.h"

#if PLATFORM_ANDROID

#include "Android/AndroidApplication.h"

#if USE_ANDROID_JNI

FName FSpacesControllerWrapper::GetClassName()
{
	return FName("com/qualcomm/snapdragon/spaces/unrealcontroller/SpacesController");
}

FSpacesControllerWrapper::FSpacesControllerWrapper()
	: FJavaClassObjectExtended(GetClassName(), "()V")
	, ResetPoseSpacesControllerMethod(GetStaticClassMethod("ResetPose", "()V"))
{}

void FSpacesControllerWrapper::ResetPose()
{
	CallStaticMethod<void>(ResetPoseSpacesControllerMethod);
	UE_LOG(LogTemp, Log, TEXT("Call Reset Pose java method."));
}

#endif //USE_ANDROID_JNI
#endif //PLATFORM_ANDROID