/******************************************************************************
 * File: UEServicesHelperWrapper.cpp
 * Copyright (c) 2021 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#include "SpacesSettingsWrapper.h"

#if PLATFORM_ANDROID

#include "Android/AndroidApplication.h"

#if USE_ANDROID_JNI

FName FSpacesSettingsWrapper::GetClassName()
{
	return FName("com/qualcomm/snapdragon/spaces/unrealserviceshelper/SpacesSettings");
}

FSpacesSettingsWrapper::FSpacesSettingsWrapper()
	: FJavaClassObjectExtended(GetClassName(), "()V")
	, SetSpacesControllerMethod(GetStaticClassMethod("SetSpacesController", "(Landroid/app/Activity;I)V"))
	, GetSpacesControllerMethod(GetStaticClassMethod("GetSpacesController", "(Landroid/app/Activity;)I"))
{}

int FSpacesSettingsWrapper::GetSpacesController()
{
	int id_controller = CallStaticMethod<int>(GetSpacesControllerMethod, AndroidJavaEnv::GetGameActivityThis());
	UE_LOG(LogTemp, Log, TEXT("GetSpacesController | ID Controller = %u"), id_controller);
	return id_controller;
}

void FSpacesSettingsWrapper::SetSpacesController(int id_controller)
{
	CallStaticMethod<void>(SetSpacesControllerMethod, AndroidJavaEnv::GetGameActivityThis(), id_controller);
	UE_LOG(LogTemp, Log, TEXT("SetSpacesController | ID Controller = %u"), id_controller);
}

#endif //USE_ANDROID_JNI
#endif //PLATFORM_ANDROID