/******************************************************************************
 * File: SpacesCoreExtension.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "SpacesExtension.h"

class FSpacesCapture;
struct FSpacesComponentVersion;

class FSpacesCoreExtension : public FSpacesExtension
{	
public:

	FSpacesCoreExtension();
	virtual ~FSpacesCoreExtension() override;

	/** IOpenXRExtensionPlugin implementation */
	virtual bool GetCustomLoader(PFN_xrGetInstanceProcAddr* OutGetProcAddr) override;
	virtual void PostCreateInstance(XrInstance InInstance) override;
	virtual bool IsStandaloneStereoOnlyDevice() override;
	virtual FString GetDisplayName() override;
	virtual bool GetRequiredExtensions(TArray<const ANSICHAR*>& OutExtensions) override;
	virtual IOpenXRCustomCaptureSupport* GetCustomCaptureSupport(const EARCaptureType CaptureType) override;
	virtual bool GetSpectatorScreenController(FHeadMountedDisplayBase* InHMDBase, TUniquePtr<FDefaultSpectatorScreenController>& OutSpectatorScreenController) override;
	virtual const void* OnCreateSession(XrInstance InInstance, XrSystemId InSystem, const void* InNext) override;
	virtual const void* OnEndProjectionLayer(XrSession InSession, int32 InLayerIndex, const void* InNext, XrCompositionLayerFlags& OutFlags) override;

	
	XrTime  XrTimeFromDateTime(const FDateTime& DateTime) const;
	FDateTime DateTimeFromXrTime(const XrTime& XRTime) const;
	bool GetComponentVersions(TArray<FSpacesComponentVersion>& ComponentVersions) const;
protected:

private:
	
	TMap<EARCaptureType, TUniquePtr<FSpacesCapture>> CaptureSupport;
	void* LoaderHandle = nullptr;

	static void RuntimeCheck();
	
	
};
