﻿/******************************************************************************
 * File: SpacesLabel.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#define DEFINE_LABEL(Value, ...)\
	template<>																											\
	struct SnapdragonSpaces::TLabel<__VA_ARGS__>{																		\
		static constexpr TCHAR Label[] = TEXT(#Value);																	\
	};																													\
	constexpr TCHAR SnapdragonSpaces::TLabel<__VA_ARGS__>::Label[];														\
	

namespace SnapdragonSpaces
{
	/***
	 * @brief Helper class to manage class labels for debugging purposes
	 * @details Used to assign a readable label to a class at compile time
	 * @param Keys Parameters to create the TLabel specialization,
	 * each combination of parameters has a unique label
	 */
	template<typename... Keys>
	struct TLabel
	{
		static constexpr TCHAR Label[] = TEXT("");
	};
}
