﻿/******************************************************************************
 * File: SpacesOpenXRIntercept.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once
#include "External/openxr/openxr.h"
#include "Templates/UnrealTemplate.h"

#define INTERCEPT_CALL_LIST(_)			\
	_(xrEnumerateEnvironmentBlendModes)	\
	_(xrEndFrame)						\
	_(xrCreateReferenceSpace)			\
	_(xrApplyHapticFeedback)

#define INTERCEPT_CALL_DECLARATION(Function)					\
	extern PFN_##Function Function##_Native;					\
	XRAPI_ATTR TRemovePointer<PFN_##Function>::Type Function##_Intercept;

namespace SpacesOpenXRIntercept
{
	INTERCEPT_CALL_LIST(INTERCEPT_CALL_DECLARATION)
	
	/************************************ Get instance proc addr interception ***********************************/
	INTERCEPT_CALL_DECLARATION(xrGetInstanceProcAddr)
	/************************************************************************************************************/
	extern bool bPassthroughSupported;
};
