/******************************************************************************
 * File: SpacesRuntimeModule.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleInterface.h"


class FSpacesExtension;
enum class ESpacesExtension : uint8;

class FSpacesRuntimeModule : public IModuleInterface
{
public:

	static FSpacesRuntimeModule& Get();

	const TMap<ESpacesExtension,  TUniquePtr<FSpacesExtension>>& GetLoadedExtensions() const;
	FSpacesExtension* GetLoadedExtension(ESpacesExtension Extension) const;
	
	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

private:
	TMap<ESpacesExtension,  TUniquePtr<FSpacesExtension>> LoadedExtensions;
	
	void LoadSpacesExtensions();
};
