﻿/******************************************************************************
 * File: SpacesSpatialAnchor.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "SpacesCommon.h"
#include "SpacesSpatialAnchorExtension.h"

class FSpacesSpatialAnchor
{
public:

	EARTrackingState GetUpdatedTransform(XrSpace TrackingSpace, XrTime DisplayTime, float worldToMeterScale, FTransform& Transform) const;
	
	XrSpatialAnchorMSFT GetAnchor() const;
	XrSpace GetAnchorSpace() const;
	FName GetSavedAnchorName() const;

	bool IsValid() const;

	FSpacesSpatialAnchor() = default;
	FSpacesSpatialAnchor(XrInstance InInstance, XrSession InSession, XrSpace TrackingSpace, XrTime DisplayTime, XrPosef InPose);
	FSpacesSpatialAnchor(XrInstance InInstance, XrSession InSession, XrSpatialAnchorMSFT SpatialAnchor);
	
	FSpacesSpatialAnchor(FSpacesSpatialAnchor&& Other) noexcept;
	FSpacesSpatialAnchor& operator=(FSpacesSpatialAnchor&& Other) noexcept;

	FSpacesSpatialAnchor(const FSpacesSpatialAnchor&) = delete;
	FSpacesSpatialAnchor& operator=(const FSpacesSpatialAnchor&) = delete;
	
	~FSpacesSpatialAnchor();

	bool Save(XrSpatialAnchorStoreConnectionMSFT AnchorStore, XrSpatialAnchorPersistenceNameMSFT PersistenceName) const;
private:
	SnapdragonSpaces::FSpatialAnchorMSFTHandle Anchor;
	SnapdragonSpaces::FSpatialAnchorSpaceMSFTHandle  AnchorSpace;
	FName SavedAnchorName;
	    
};
