/******************************************************************************
 * File: SpacesEngineSubsystem.h
 * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */


#include "SubSystems/SpacesEngineSubsystem.h"
#include "SpacesOpenXRIntercept.h"

bool USpacesEngineSubsystem::GetPassthroughEnabled() const
{
	return bPassthroughEnabled;
}

void USpacesEngineSubsystem::SetPassthroughEnabled(const bool bNewPassthroughEnabled)
{
	if(bPassthroughEnabled != bNewPassthroughEnabled)
	{
		bPassthroughEnabled = bNewPassthroughEnabled;
		OnChangePassthrough.Broadcast(bPassthroughEnabled);
	}
}

bool USpacesEngineSubsystem::IsPassthroughSupported() const
{
	return SpacesOpenXRIntercept::bPassthroughSupported;
}
