/******************************************************************************
 * File: SpacesGameUserSettings.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameUserSettings.h"
#include "SpacesGameUserSettings.generated.h"

#define SPACES_GAMEUSERSETTINGS_VERSION 1

UENUM(BlueprintType)
enum class ESpacesControllerType : uint8
{
	ECT_GazeController = 0 UMETA(DisplayName="Gaze Controller"),
	ECT_3DOFController = 1 UMETA(DisplayName="3DOF Controller"),
};

UCLASS(config = GameUserSettings, configdonotcheckdefaults)
class SPACESRUNTIME_API USpacesGameUserSettings : public UGameUserSettings
{
	GENERATED_BODY()

public:
	virtual bool IsVersionValid() override;
	virtual void UpdateVersion() override;
	
	UFUNCTION(BlueprintPure, Category="Snapdragon Spaces|Spaces Settings")
	int GetSpacesController() const;
	
	UFUNCTION(BlueprintCallable, Category="Snapdragon Spaces|Spaces Settings")
	void SetSpacesController(int controller_id);

protected:
	UPROPERTY(config)
	int SpacesIDController = 0;
};
