/******************************************************************************
 * File: SpacesEngineSubsystem.h
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

#pragma once

#include "CoreMinimal.h"
#include "Subsystems/EngineSubsystem.h"
#include "SpacesEngineSubsystem.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE_TwoParams(FOnSpacesReferenceSpaceChangePending, bool, bIsTransformValid, FTransform, TransformInPreviousSpace);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_TwoParams(FOnSpacesAnchorIsSaved, bool, bSuccessful, FName, AnchorName);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnSpacesSpatialMeshNormalsComputed, bool, bSuccess);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnSpacesImageTrackingIsReady, bool, bSuccessful);
DECLARE_DYNAMIC_MULTICAST_DELEGATE_OneParam(FOnChangePassthrough, bool, bIsEnabled);

UCLASS()
class SPACESRUNTIME_API USpacesEngineSubsystem : public UEngineSubsystem
{
	GENERATED_BODY()

public:
	
	UPROPERTY(BlueprintAssignable, Category="Snapdragon Spaces")
	FOnSpacesReferenceSpaceChangePending OnSpacesReferenceSpaceChangePending;
	UPROPERTY(BlueprintAssignable, Category="Snapdragon Spaces")
	FOnSpacesAnchorIsSaved OnSpacesAnchorIsSaved;
	UPROPERTY(BlueprintAssignable, Category="Snapdragon Spaces")
	FOnSpacesSpatialMeshNormalsComputed OnSpacesSpatialMeshNormalsComputed;
	UPROPERTY(BlueprintAssignable, Category="Snapdragon Spaces")
	FOnSpacesImageTrackingIsReady OnSpacesImageTrackingIsReady;

	UFUNCTION(BlueprintPure,BlueprintInternalUseOnly)
	bool GetPassthroughEnabled() const;
	UFUNCTION(BlueprintCallable,BlueprintInternalUseOnly)
	void SetPassthroughEnabled(const bool bNewPassthroughEnabled);
	UPROPERTY(BlueprintAssignable, Category="Snapdragon Spaces|Passthrough")
	FOnChangePassthrough  OnChangePassthrough ;
	UFUNCTION(BlueprintPure,  Category="Snapdragon Spaces|Passthrough")
	bool IsPassthroughSupported() const;

protected:
	//bool responsible of toggling the Visual See Through
	UPROPERTY(BlueprintGetter=GetPassthroughEnabled, BlueprintSetter=SetPassthroughEnabled, Category="Snapdragon Spaces|Passthrough")
	bool bPassthroughEnabled = false;
	
};
