/******************************************************************************
 * File: SpacesRuntime.Build.cs
 * Copyright (c) 2022 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
 *
 * Confidential and Proprietary - Qualcomm Technologies, Inc.
 *
 */

using System.IO;
using UnrealBuildTool;

public class SpacesRuntime : ModuleRules
{
	public SpacesRuntime(ReadOnlyTargetRules Target) : base(Target)
	{
		// StrictIncludes mode from BuildPlugin automation
		PCHUsage = PCHUsageMode.NoPCHs;
		bUseUnity = false;

		// bUseRTTI = true;
		// bEnableExceptions = true;
		CppStandard = CppStandardVersion.Cpp17;
		
		PublicDefinitions.Add("XR_USE_TIMESPEC=1");
		
		
		PrivateIncludePaths.AddRange(
			new string[] {
				Path.Combine("SpacesRuntime", "Private"),
			}
			);
			
		PublicDependencyModuleNames.AddRange(
			new string[]
			{
				"Core",
				"DeveloperSettings",
				"AugmentedReality"
			}
			);
			
		PrivateDependencyModuleNames.AddRange(
			new string[]
			{
				"CoreUObject",
				"Engine",
				"InputCore",
				"HeadMountedDisplay",
				"AugmentedReality",
				"OpenXRHMD",
				"OpenXRAR",
				"OpenXRInput",
				"ProceduralMeshComponent",
				"RenderCore",
			}
		);
		
		if (Target.Platform == UnrealTargetPlatform.Android)
		{
			PublicDefinitions.Add("XR_USE_PLATFORM_ANDROID=1");

			PrivateDependencyModuleNames.AddRange(
				new string[]
				{ 
					"ApplicationCore", 
					"Launch",
				}
			);
			// AndroidPlugin
			{
				string ModulePath = Utils.MakePathRelativeTo(ModuleDirectory, Target.RelativeEnginePath);
				AdditionalPropertiesForReceipt.Add("AndroidPlugin", Path.Combine(ModulePath, "SpacesRuntime_UPL.xml"));
			}
		}
	}
}
